﻿TITAN_HEALBOT_ID="HealBot"

local returnText = ""
local thb_ver=nil
local thb_tt=nil
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local _

function TitanPanelHealBotButton_OnLoad(self)
	thb_ver = HealBot_RetVersion()
	thb_tt = "HealBot Options"
    self.registry = {
      id = TITAN_HEALBOT_ID,
      menuText = TITAN_HEALBOT_ID,
      version = thb_ver,
      buttonTextFunction = "HealBot_Titan_GetButtonText",
      category = "Interface",
      tooltipTitle = thb_tt,
      tooltipTextFunction = "HealBot_Titan_GetTooltipText",
  	  icon = "Interface\\AddOns\\TitanHealBot\\Images\\HealBot",
      iconWidth = 16,
		controlVariables = {
			ShowIcon = true,
			ShowLabelText = true,
			ShowRegularText = true,
			ShowColoredText = true,
			DisplayOnRightSide = true,
		},
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 0,
			ShowRegularText = 0,
			ShowColoredText = 1,
			DisplayOnRightSide = 1,
	  	}
    };
end

function HealBot_Titan_GetTooltipText()
    return HEALBOT_TITAN_TOOLTIP;
end

function HealBot_Titan_GetButtonText()
    returnText = ""
	if not HealBot_Data then return TitanUtils_GetNormalText("HealBot"); end
    
	if (TitanGetVar(TITAN_HEALBOT_ID, "ShowRegularText")) then 
		if (TitanGetVar(TITAN_HEALBOT_ID, "ShowColoredText")) then 
			if HealBot_Config.DisableHealBot==1 then
				returnText=returnText..TitanUtils_GetRedText(HEALBOT_SKIN_DISTEXT)
			else
				returnText=returnText..TitanUtils_GetHighlightText(Healbot_Config_Skins.Current_Skin)
			end
		else
			if HealBot_Config.DisableHealBot==1 then
				returnText=returnText..TitanUtils_GetNormalText(HEALBOT_SKIN_DISTEXT)
			else
				returnText=returnText..TitanUtils_GetNormalText(Healbot_Config_Skins.Current_Skin)
			end
		end
    end

	if (TitanGetVar(TITAN_HEALBOT_ID, "ShowLabelText")) then 
		if returnText=="" then 
			returnText=TitanUtils_GetNormalText("HealBot"); 
		else
			returnText=TitanUtils_GetNormalText("HealBot: ")..returnText; 
		end
	end
    return returnText;
end

local info = {}
local currentLevel=0
local HealBot_Titan_Bars_List = {}
local HealBot_Titan_EmergencyFilter_List = {}
local HealBot_Titan_ExtraSort_List = {}
local skinName = nil
function TitanPanelRightClickMenu_PrepareHealBotMenu()
    if HealBot_Data then
        HealBot_Titan_Bars_List = {
              HEALBOT_OPTIONS_SELFHEALS,
              HEALBOT_OPTIONS_GROUPHEALS,
              HEALBOT_OPTIONS_TANKHEALS,
              HEALBOT_CLASSES_HEALERS,
              HEALBOT_OPTIONS_EMERGENCYHEALS,
              HEALBOT_OPTIONS_PETHEALS,
              HEALBOT_OPTIONS_MYTARGET,
              HEALBOT_FOCUS,
              HEALBOT_VEHICLE,
              HEALBOT_CUSTOM_CASTBY_ENEMY,
              HEALBOT_OPTIONS_TARGETHEALS,
              }
      
        HealBot_Titan_EmergencyFilter_List = HealBot_Options_copyTable(HealBot_Options_EmergencyFilter_List)
        HealBot_Titan_ExtraSort_List = HealBot_Options_copyTable(HealBot_Options_ExtraSort_List)
      
        if UIDROPDOWNMENU_MENU_LEVEL == 1 then
            TitanPanelRightClickMenu_AddTitle(TITAN_HEALBOT_ID.." "..thb_ver) --TitanPlugins[TITAN_HEALBOT_ID].menuText)
            TitanPanelRightClickMenu_AddSpacer();
                
            for x,_ in pairs(info) do
              info[x]=nil
            end
            info.text = HEALBOT_TITAN_SMARTCAST
            info.func = HealBot_Titan_ToggleSmartCast;
            info.checked = HealBot_Options_EnableSmartCast:GetChecked();
            info.value = HealBot_Config.SmartCast;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

            --for x,_ in pairs(info) do
            --  info[x]=nil
            --end
            info.text = HEALBOT_TITAN_MONITORBUFFS
            info.func = HealBot_Titan_ToggleMonitorBuffs;
            info.checked = HealBot_Options_MonitorBuffs:GetChecked();
            info.value = HealBot_Config_Buffs.BuffWatch;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
            
            --for x,_ in pairs(info) do
            --  info[x]=nil
            --end
            info.text = HEALBOT_TITAN_MONITORDEBUFFS
            info.func = HealBot_Titan_ToggleMonitorDebuffs;
            info.checked = HealBot_Options_MonitorDebuffs:GetChecked();
            info.value = HealBot_Config_Cures.DebuffWatch;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
            
            TitanPanelRightClickMenu_AddSpacer();

            for x,_ in pairs(info) do
              info[x]=nil
            end
            info.text = HEALBOT_OPTIONS_TAB_SKIN;
            info.hasArrow = 1;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
            
            --for x,_ in pairs(info) do
            --  info[x]=nil
            --end
            info.text = HEALBOT_TITAN_SHOWBARS;
            info.hasArrow = 1;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
            
            TitanPanelRightClickMenu_AddSpacer()	

            TitanPanelRightClickMenu_AddToggleIcon(TITAN_HEALBOT_ID)
            TitanPanelRightClickMenu_AddToggleLabelText(TITAN_HEALBOT_ID)
            for x,_ in pairs(info) do
              info[x]=nil
            end
            info.text = L["TITAN_PANEL_MENU_SHOW_PLUGIN_TEXT"];
            info.func = function()
                TitanPanelRightClickMenu_ToggleVar({TITAN_HEALBOT_ID, "ShowRegularText", nil})
            end
            info.checked = TitanGetVar(TITAN_HEALBOT_ID, "ShowRegularText")
            info.keepShownOnClick = 1;
            UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
            TitanPanelRightClickMenu_AddToggleColoredText(TITAN_HEALBOT_ID)

            TitanPanelRightClickMenu_AddSpacer()	
            TitanPanelRightClickMenu_AddCommand(L["TITAN_PANEL_MENU_HIDE"], TITAN_HEALBOT_ID, TITAN_PANEL_MENU_FUNC_HIDE)
            
            x=HealBot_Comms_ReportVer()
            if x then
                TitanPanelRightClickMenu_AddSpacer()	
                TitanPanelRightClickMenu_AddTitle("Version "..x)
                TitanPanelRightClickMenu_AddTitle("is available at")
                TitanPanelRightClickMenu_AddTitle(HEALBOT_ABOUT_URL)
            end
        
        elseif UIDROPDOWNMENU_MENU_LEVEL == 2 then
            for x,_ in pairs(info) do
                info[x]=nil
            end
            if UIDROPDOWNMENU_MENU_VALUE == HEALBOT_OPTIONS_TAB_SKIN then
                TitanPanelRightClickMenu_AddTitle(HEALBOT_OPTIONS_TAB_SKIN, UIDROPDOWNMENU_MENU_LEVEL);
                for i in pairs (Healbot_Config_Skins.Skins) do
                    info.text = Healbot_Config_Skins.Skins[i];
                    info.func = HealBot_Titan_SkinUpdate;
                    info.value = Healbot_Config_Skins.Skins[i];
                    info.checked=false
                    if Healbot_Config_Skins.Skins[i]==Healbot_Config_Skins.Current_Skin then info.checked=true; end
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                end
            elseif UIDROPDOWNMENU_MENU_VALUE == HEALBOT_TITAN_SHOWBARS then
                TitanPanelRightClickMenu_AddTitle(HEALBOT_TITAN_SHOWBARS, UIDROPDOWNMENU_MENU_LEVEL);
                for i=1, getn(HealBot_Titan_Bars_List), 1 do
                    info.text = HealBot_Titan_Bars_List[i];
                    info.func = HealBot_Titan_BarsUpdate;
                    info.checked = HealBot_Titan_BarsChecked(i)
                    info.value = HealBot_Titan_Bars_List[i];
                    info.keepShownOnClick = 1;
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                end
            end
        end
        hbtMenuInit=false
    end
end

local hbState=0
function HealBot_Titan_ToggleDisable(self)
	if self.value and self.value==1 then
		hbState=0
	else
		hbState=1
	end
	HealBot_Options_ToggleHealBot(hbState)
	HealBot_Options_DisableHealBot:SetChecked(HealBot_Config.DisableHealBot);
end

function HealBot_Titan_ToggleSmartCast(self)
  if self.value==1 then
    HealBot_Config.SmartCast=0;
  else
    HealBot_Config.SmartCast=1;
  end
  HealBot_Options_EnableSmartCast:SetChecked(HealBot_Config.SmartCast);
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
end

function HealBot_Titan_ToggleMonitorBuffs(self)
  if self.value==1 then
    HealBot_Config_Buffs.BuffWatch=0;
  else
    HealBot_Config_Buffs.BuffWatch=1;
  end
  HealBot_Options_MonitorBuffs:SetChecked(HealBot_Config_Buffs.BuffWatch);
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
  if HealBot_Config_Buffs.BuffWatch==0 then
    HealBot_Options_MonitorBuffsInCombat:Disable();
    HealBot_DelayBuffCheck = {};
    HealBot_SetAuraChecks()
  else
    HealBot_Options_MonitorBuffsInCombat:Enable();
    HealBot_setOptions_Timer(40)
  end
end

function HealBot_Titan_ToggleMonitorDebuffs(self)
  if self.value==1 then
    HealBot_Config_Cures.DebuffWatch=0;
  else
    HealBot_Config_Cures.DebuffWatch=1;
  end
  HealBot_Options_MonitorDebuffs:SetChecked(HealBot_Config_Cures.DebuffWatch);
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
  if HealBot_Config_Cures.DebuffWatch==0 then
    HealBot_Options_MonitorDebuffsInCombat:Disable();
    HealBot_DelayDebuffCheck = {};
    HealBot_SetAuraChecks()
  else
    HealBot_Options_MonitorDebuffsInCombat:Enable();
    HealBot_setOptions_Timer(50)
  end
end

local barCheckList= {
    [1]=HEALBOT_OPTIONS_SELFHEALS,
    [2]=HEALBOT_OPTIONS_GROUPHEALS,
    [3]=HEALBOT_OPTIONS_TANKHEALS,
    [4]=HEALBOT_CLASSES_HEALERS,
    [5]=HEALBOT_OPTIONS_EMERGENCYHEALS,
    [6]=HEALBOT_OPTIONS_PETHEALS,
    [7]=HEALBOT_OPTIONS_MYTARGET,
    [8]=HEALBOT_FOCUS,
    [9]=HEALBOT_VEHICLE,
    [10]=HEALBOT_CUSTOM_CASTBY_ENEMY,
    [11]=HEALBOT_OPTIONS_TARGETHEALS,
    }
    
function HealBot_Titan_BarsChecked(i)
    for id=1,11 do
        if Healbot_Config_Skins.HealGroups[Healbot_Config_Skins.Current_Skin][id]["NAME"]==barCheckList[i] then
            if Healbot_Config_Skins.HealGroups[Healbot_Config_Skins.Current_Skin][id]["STATE"]==1 then
                return true
            else
                return false
            end
        end
    end
end

function HealBot_Titan_BarsUpdate(self)
    local newValue = 0;
    if self.checked then
      newValue=1;
    end
    for id=1,11 do
        if Healbot_Config_Skins.HealGroups[Healbot_Config_Skins.Current_Skin][id]["NAME"]==self.value then
            Healbot_Config_Skins.HealGroups[Healbot_Config_Skins.Current_Skin][id]["STATE"]=newValue;
            g=_G["HealBot_Options_HealGroups"..id]
            g:SetChecked(Healbot_Config_Skins.HealGroups[Healbot_Config_Skins.Current_Skin][id]["STATE"])
            break
        end
    end
    TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
    HealBot_Data["REFRESH"]=2;
end

function HealBot_Titan_AlertLevelUpdate(self)
  Healbot_Config_Skins.AlertLevel[Healbot_Config_Skins.Current_Skin]=self.value/100;
  HealBot_Options_AlertLevel:SetValue(Healbot_Config_Skins.AlertLevel[Healbot_Config_Skins.Current_Skin]);
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
end

function HealBot_Titan_SkinUpdate(self)
  HealBot_Options_Set_Current_Skin(self.value);
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
end

function HealBot_Titan_EFUpdate(self)
  Healbot_Config_Skins.EmergIncMonitor[Healbot_Config_Skins.Current_Skin]=self.value;
  HealBot_Options_EmergencyFilter_Refresh();
  HealBot_Data["REFRESH"]=5;
end

function HealBot_Titan_ExtraGroupsChecked(i)
  local objName=_G["HealBot_Options_EFGroup"..i];
  return objName:GetChecked();
end

local g=nil
function HealBot_Titan_ExtraGroupsUpdate(self)
  local id = self:GetID()-1
  if self.value==1 then
    Healbot_Config_Skins.ExtraIncGroup[Healbot_Config_Skins.Current_Skin][id]=false;
    self.value=0;
    g=_G["HealBot_Options_EFGroup"..id]
    g:SetChecked(nil)
  else
    Healbot_Config_Skins.ExtraIncGroup[Healbot_Config_Skins.Current_Skin][id]=true;
    self.value=1;
    g=_G["HealBot_Options_EFGroup"..id]
    g:SetChecked(1)
  end
  TitanToggleVar(TITAN_HEALBOT_ID, self:GetID());
end

function HealBot_Titan_ESUpdate(self)
  Healbot_Config_Skins.ExtraOrder[Healbot_Config_Skins.Current_Skin]=self.value;
  HealBot_Options_ExtraSort_Refresh();
  HealBot_Data["REFRESH"]=5;
end

function TitalPanelHealBotButton_OnClick(self, button)
  if button~="RightButton" and HealBot_Data then
    HealBot_ToggleOptions()
  end
end
